/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.kintai.dao.CmRotationDao;
import jp.mosp.kintai.dto.CmRotationDto;
import jp.mosp.kintai.vo.ScheduleRotationCardVo;

public class ScheduleRotationCardAction extends MosPAction{

	// コマンド
	private static final String CMD_ROTATION_CARD_SHOW   = "K1215";	// 表示(追加)
	private static final String CMD_ROTATION_CARD_SELECT = "K1216";	// 表示(選択)
	private static final String CMD_ROTATION_CARD_INSERT = "K1217";	// 登録
	private static final String CMD_ROTATION_CARD_UPDATE = "K1218";	// 更新

	/**
	 * コンストラクタ
	 */
	public ScheduleRotationCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// VOの取得及び設定
		ScheduleRotationCardVo vo = new ScheduleRotationCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DBコネクション取得
		getConnection();
		// DAOの準備
		CmRotationDao dao = new CmRotationDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// コード区分プルダウンリスト作成
		vo.aryPltWorkType = getWorkTypeArrayWithWeekHoliday();
		vo.aryPltHoliday  = getApplicableFlagArray();
		// DTOの取得
		CmRotationDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof CmRotationDto ? (CmRotationDto)obj : null;
		// ユーザー情報取得
		getInfo(user.getUserId());
		// コマンド毎の処理
		if (cmd.equals(CMD_ROTATION_CARD_SHOW)) {
			// 表示(新規)
			vo.setDefaultValues();			
			vo.setMode(ScheduleRotationCardVo.MODE_INSERT);		
		} else if (cmd.equals(CMD_ROTATION_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(mKihon.getKCode(), key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROTATION_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_ROTATION_CARD_UPDATE)) {	
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmRotationDto insert(ScheduleRotationCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// コネクションの取得及びDAOの準備
		getConnection();
		CmRotationDao dao = new CmRotationDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(mKihon.getKCode(), vo.getTxtRTCode()), vo);
		// DTOの準備
		CmRotationDto dto = new CmRotationDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		dto.setKCode(mKihon.getKCode());
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(mKihon.getKCode(), dto.getRtCode());
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private CmRotationDto update(ScheduleRotationCardVo vo, CmRotationDto dto) throws Exception {
		vo.setMode(ScheduleRotationCardVo.MODE_UPDATE);
		// パラメータの妥当性確認
		vo.validate();
		// DAOの準備
		CmRotationDao dao = new CmRotationDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(mKihon.getKCode(), vo.getTxtRTCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		dto.setKCode(mKihon.getKCode());
		// データの更新
		dao.update(dto);
		// DTOの再取得
		CmRotationDto retDto = dao.findForKey(mKihon.getKCode(), dto.getRtCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(ScheduleRotationCardVo vo) throws Exception {
		// モード設定
		vo.setMode(ScheduleRotationCardVo.MODE_UPDATE);
	}

}
